/**
 * PLL configuration
 *
 * This Verilog module was generated automatically
 * using the icepll tool from the IceStorm project.
 * Use at your own risk.
 *
 * Given input frequency:        25.000 MHz
 * Requested output frequency:  100.000 MHz
 * Achieved output frequency:   100.000 MHz
 */

module clkgen(
	input  clock_in,//25 MHz clock input
	output clk_hi,	//100 MHZ SDRAM controller
	output clk,		//25 MHz core frequency
	output rst		// Reset signal output
	);

	reg irst = 0;
	reg [2:0] div_clk = 0;

	always @(posedge clock_in)
		div_clk <= div_clk + 3'd1;

`ifdef __ICARUS__ 
	assign clk_hi = clock_in;
	reg [1:0] div = 0;
	always @(posedge clock_in)
		div <= div + 1;
	assign clk = div_clk[2];
	reg locked = 1;
	assign rst = irst;
`else
	wire locked;
	SB_PLL40_CORE #(
			.FEEDBACK_PATH("SIMPLE"),
			.DIVR(4'b0000),		// DIVR =  0
			.DIVF(7'b0011111),	// DIVF = 31
			.DIVQ(3'b011),		// DIVQ =  3
			.FILTER_RANGE(3'b010)	// FILTER_RANGE = 2
		) uut (
			.LOCK(locked),
			.RESETB(1'b1),
			.BYPASS(1'b0),
			.REFERENCECLK(clock_in),
			.PLLOUTGLOBAL(clk_hi),	//By default connected to global net
			);
		
	// Reset global buffer
	SB_GB rst_gb ( .USER_SIGNAL_TO_GLOBAL_BUFFER(irst), 
					.GLOBAL_BUFFER_OUTPUT(rst) );



	SB_GB clk_gb_hi ( .USER_SIGNAL_TO_GLOBAL_BUFFER(div_clk[2]), 
					.GLOBAL_BUFFER_OUTPUT(clk) );
`endif
	reg [6:0] rstcnt = 0;
	always @(posedge clk) begin
		if( rstcnt < 3 ) begin
			irst <= 1'b1;
			rstcnt <= rstcnt + 1;
		end
		else if( rstcnt < 62 ) begin
			irst <= 1'b0;
			rstcnt <= rstcnt + 1;
		end
		else begin
			irst <= 1'b1;
		end
	end
endmodule
