`define BUF_WIDTH 3

module fifo_test();
reg clk, rst, wr_en, rd_en ;
reg[7:0] buf_in;
reg[7:0] tempdata;
wire [7:0] buf_out;

synchronous_fifo #(.DEPTH(`BUF_WIDTH)) ff
(
		 .clk(clk), .rst(rst), .data_in(buf_in), .data_out(buf_out), 
         .wr_en(wr_en), .rd_en(rd_en), 
		 .empty(buf_empty), .full(buf_full)
);
initial
begin
   clk = 0;
   rst = 1;
        rd_en = 0;
        wr_en = 0;
        tempdata = 0;
        buf_in = 0;


        #15 rst = 0;
		#15 rst = 1;
  
        push(1);
        fork
           push(2);
           pop(tempdata);
        join              //push and pop together   
        push(10);
        push(20);
        push(30);
        push(40);
        push(50);
        push(60);
        push(70);
        push(80);
        push(90);
        push(100);
        push(110);
        push(120);
        push(130);

        pop(tempdata);
        push(tempdata);
        pop(tempdata);
        pop(tempdata);
        pop(tempdata);
        pop(tempdata);
   push(140);
        pop(tempdata);
        push(tempdata);//
        pop(tempdata);
        pop(tempdata);
        pop(tempdata);
        pop(tempdata);
        pop(tempdata);
        pop(tempdata);
        pop(tempdata);
        pop(tempdata);
        pop(tempdata);
        pop(tempdata);
        pop(tempdata);
        push(5);
        pop(tempdata);
		$finish;
end

always
   #5 clk = ~clk;

task push;
input[7:0] data;


   if( buf_full )
            $display("---Cannot push: Buffer Full---");
        else
        begin
           $display("Pushed %d",data );
           buf_in = data;
           wr_en = 1;
                @(posedge clk);
                #1 wr_en = 0;
        end

endtask

task pop;
output [7:0] data;

   if( buf_empty )
            $display("---Cannot Pop: Buffer Empty---");
   else
        begin

     rd_en = 1;
          @(posedge clk);

          #1 rd_en = 0;
          data = buf_out;
           $display("-------------------------------Poped %d", data);

        end
endtask

endmodule

/* # Pushed 1
# Pushed 2
# -------------------------------Poped 1
# Pushed 10
# Pushed 20
# Pushed 30
# Pushed 40
# Pushed 50
# Pushed 60
# Pushed 70
# ---Cannot push: Buffer Full---
# ---Cannot push: Buffer Full---
# ---Cannot push: Buffer Full---
# ---Cannot push: Buffer Full---
# ---Cannot push: Buffer Full---
# ---Cannot push: Buffer Full---
# -------------------------------Poped 2
# Pushed 2
# -------------------------------Poped 10
# -------------------------------Poped 20
# -------------------------------Poped 30
# -------------------------------Poped 40
# Pushed 140
# -------------------------------Poped 50
# Pushed 50
# -------------------------------Poped 60
# -------------------------------Poped 70
# -------------------------------Poped 2
# -------------------------------Poped 140
# -------------------------------Poped 50
# ---Cannot Pop: Buffer Empty---
# ---Cannot Pop: Buffer Empty---
# ---Cannot Pop: Buffer Empty---
# ---Cannot Pop: Buffer Empty---
# ---Cannot Pop: Buffer Empty---
# ---Cannot Pop: Buffer Empty---
# Pushed 5
# -------------------------------Poped 5
*/
