`timescale 1ns/1ps

module usart_tx_testbench();
	reg clk, rst;
	wire u_valid;
	reg  u_ready;
	wire u_overflow;
	wire [7:0] u_data8;
	reg rxd_pin;

	usart_rx_fifo urx( .clk(clk), .rst(rst),
		.valid(u_valid), .ready(u_ready),
		.overflow(u_overflow), .data(u_data8),
		.u_rx_pin(rxd_pin)
	);


	initial
	begin
		$dumpfile("sim/usartrx_buf_top.lxt");
		$dumpvars(0,urx);
		//Input config 
		u_ready <= 1'b0;
		rxd_pin <= 1'b1;
		
		clk <= 1'b0;
		rst <= 1'b1;
		repeat(10) #200 clk <= ~clk;
		rst <= 1'b0;
		repeat(10) #200 clk <= ~clk;
		rst <= 1'b1;
		#40 ;
		repeat(500) #17360 rxd_pin <= ~rxd_pin;
		$finish;
	end

	always #40 clk = ~clk;
	
	always @(posedge clk) begin
		if(u_valid && ~u_ready) u_ready <= 1'b1;
		else u_ready <= 1'b0;
	end

endmodule
