`timescale 1ns/1ps

module usart_tx_testbench();
	reg clk,rst;
	wire clk_rx, clk_tx;


	usart_brr #(.N(15),.K(2416)) usart_presc( 
		.clk_in(clk), .clk_out(clk_rx), .rst(rst)
	);

	usart_tx_div usart_tx_div(.inclk(clk_rx), .rst(rst), .outclk(clk_tx) );
	reg ack_in;
	reg rxd_pin;
	wire [7:0] rx_data8;
	wire rx_rdy;

	usart_rx urx( .clk(clk_rx), .rst(rst),
		.ack_in(ack_in), .rxd_in(rxd_pin),
		.rdy(rx_rdy), .data(rx_data8)
	);

	initial
	begin
		$dumpfile("sim/usartrx_top.lxt");
		$dumpvars(0,urx);
		$dumpvars(0,usart_presc);
		//Input config 
		ack_in <= 1'b0;
		rxd_pin <= 1'b1;
		
		clk <= 1'b0;
		rst <= 1'b1;
		repeat(10) #200 clk <= ~clk;
		rst <= 1'b0;
		repeat(10) #200 clk <= ~clk;
		rst <= 1'b1;
		#40 ;
		repeat(100) #17360 rxd_pin <= ~rxd_pin;
		$finish;
	end

	always #40 clk = ~clk;

endmodule
