`timescale 1ns/1ps

module usart_tx_testbench();
	reg clk,rst;
	reg b_valid;
	wire b_ready;
	reg [7:0] tx_buffer[0:256];
	reg [7:0] ch_data;
	reg [7:0] tx_pos;
	wire tx_pin;

	usart_tx_fifo utx( .clk(clk), .rst(rst),
		.valid(b_valid), .ready(b_ready),
		.data(ch_data), .u_tx_pin(tx_pin)
	);
	integer i;

	initial
	begin
		$dumpfile("sim/usarttx_buf_top.lxt");
		$dumpvars(0,utx);
		//for (i = 0; i < 16; i = i + 1) $dumpvars(0, utx.tx_fifo.memory[i]);
		for(i=0;i<256;i=i+1) 
			tx_buffer[i] = i;
		b_valid = 1'b0;
		tx_pos = 8'd0;
		clk = 1'b0;
		rst = 1'b1;
		repeat(10) #200 clk <= ~clk;
		rst = 1'b0;
		repeat(10) #200 clk <= ~clk;
		rst = 1'b1;
		#40000000;
		$finish;
	end
	
	always #40 clk <= ~clk;


	always @(posedge clk) begin
		if(~rst) begin
			tx_pos <= 1'b0;
		end else
		if(b_ready && !b_valid) begin
			ch_data <= tx_buffer[tx_pos];
			b_valid <= 1'b1;
			//if(tx_pos==8'd255) $finish;
		end else
		if(b_valid) begin
			b_valid <= 1'b0;
			tx_pos <= tx_pos + 1;
		end
	end

endmodule
