module usart_rx_u(
	input clk,
	input rst,
	input rxd,
	output reg [7:0] leds
);


	wire clk_rx;
	wire clk_tx;
	usart_brr #(.N(15),.K(2416)) usart_presc( 
		.clk_in(clk), .clk_out(clk_rx), .rst(rst)
	);
	wire [7:0] db8;
	wire rdy;
	
	usart_rx urx( .clk(clk_rx), .rst(rst),
		.rxd_in(rxd), .data(db8), .rdy(rdy), .ack_in(1'b0) );

	always @(posedge rdy) begin
		leds <= db8;
	end

endmodule
