module usart_rx_buf_u(
	input clk,
	input rst,
	input rxd,
	output [7:0] leds
);

	wire u_valid; 
	reg u_ready;
	wire u_overflow;
	wire [7:0] u_data8;
	

	usart_rx_fifo urx( .clk(clk), .rst(rst),
		.valid(u_valid), .ready(u_ready),
		.overflow(u_overflow), .data(u_data8),
		.u_rx_pin(rxd)
	);

	assign leds = u_data8;

	always @(posedge clk or negedge rst) begin
		if(~rst) begin
			u_ready <= 1'b0;
		end /*rst*/
		else begin
			if(u_valid && ~u_ready) u_ready <= 1'b1;
			else u_ready <= 1'b0;
		end /*rst*/
	end

endmodule
