module usart_tx_u( 
	input rst, 
	input clk,
	output tx_pin
);

	wire clk_rx;
	wire clk_tx;
	usart_brr #(.N(15),.K(2416)) usart_presc( 
		.clk_in(clk), .clk_out(clk_rx), .rst(rst)
	);
	
	usart_tx_div usart_tx_div(.inclk(clk_rx), .rst(rst), .outclk(clk_tx) );

	
	wire [7:0] tx_data;
	assign tx_data = "H";
	reg start_tx;
	wire tx_rdy;

	reg [1:0] state,nextstate;

	usart_tx utx( .clk(clk_tx), .rst(rst),
		.en(start_tx), .data(tx_data),
		.tx(tx_pin), .rdy(tx_rdy)
	);


	always @(posedge clk or negedge rst)
	begin
		if(~rst)  begin
			state <= 0;
		end
		else begin
			(* full_case,parallel_case *)
			case(state)
				0: begin
					if(tx_rdy) begin
						nextstate = 1;
						start_tx = 1;
					end
				end
				1: begin
					nextstate = tx_rdy?1:2;
				end
				2: begin
					nextstate = tx_rdy?3:2;
					start_tx = tx_rdy?1:0;
				end
				3: begin
					if( tx_rdy ) begin
						nextstate = 0;
					end
				end
			endcase
			state <= nextstate;
		end
	end
	

endmodule
